#==========================================================================
# 		BOOTSTRAP WEIBULL-POT METHODS
#==========================================================================
 getwd()
 source(file.path(WERinR,"Recipes/EVA/EVA-functions.R"))
 Print<-function(x) {cat(x,"\n");  flush.console()}

library(evir)


# Select Weibull indices to be run
ws<-c(0.75,0.9,1,1.1,1.25,1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75,4)

wfile<-"Nextw.Rdata"
if (file.exists(wfile))
 {load(wfile)
  if(iw>length(ws)) 
   stop("Bootstrap complete - Consolidate files")
  w<-ws[iw]
  iw<-iw+1
  save(iw,file=wfile)
 }else{
  w<-ws[1]
  iw<-2
  save(iw,file=wfile)
 }

if (!(iw-1)>length(ws))
{#
Print(paste("Bootstrapping Weib-POT methods for w =",w))

Ms<-100
T=1e4
rs=c(5,10,15,20,30,50,100,150,200,300,500)

plotit=FALSE

nM<-length(Ms)
nr<-length(rs)
y50<--log(-log(1-1/50))
y100<--log(-log(1-1/100))
y1000<--log(-log(1-1/1000))
y10000<--log(-log(1-1/10000))


boot=function(m,r)
{Z<-data.frame(Uxms=numeric(),Dxms=numeric(),
    Uxmw=numeric(),Dxmw=numeric(),wxmw=numeric(),
    Uxmo=numeric(),Dxmo=numeric(),wxmo=numeric(),
    X50=numeric(),W50=numeric(),O50=numeric(),
    X100=numeric(),W100=numeric(),O100=numeric(),
    X1000=numeric(),W1000=numeric(),O1000=numeric(),
    X10000=numeric(),W10000=numeric(),O10000=numeric())
 Print(paste("M =",Ms[m],"r =",rs[r]))
 y<-y.ximis.mean(Ms[m],R)
 P50<-1/50*R/Ms[m]
 P100<-1/100*R/Ms[m]
 P1000<-1/1000*R/Ms[m]
 P10000<-1/10000*R/Ms[m]
 N<-rs[r]*R
#P<-1-(c(1:N)/(N+1))
 P<-1-((c(1:N)-0.44)/(N+0.12))
# Wt<-(N+1-c(1:N))*(N+2-c(1:N))/(N+1)/(N+2)
# wt<-1/Wt[1:Ms[m]]
 	
 for (t in c(1:T))
 {V<-sort((-log(runif(N)))^(1/w),decreasing=TRUE)
  lV<-log(V)[1:Ms[m]]
  wy<-log(-log(1-P))[1:Ms[m]]
# wbl<-lm(wy[-100]~lV[-100],weights=wt[-100])
  wbl<-lm(wy~lV)
  ww<-summary(wbl)$coefficients[2]
  wC<-exp(summary(wbl)$coefficients[1]/ww)

#plot(lV,wy,cex=1.5,lwd=2)
#abline(wbl,lwd=3)
#Print(c(ww,wC))

 V<-V[1:Ms[m]]
 x<-rs[r]*R
#errfn=function(x){p<-(1-(c(1:x)/(x+1)))[1:Ms[m]];
#                     summary(lm(log(-log(1-p))~log(V)),weights=wt)$sigma}
 errfn=function(x){p<-(1-(c(1:x)-0.44)/(x+0.12))[1:Ms[m]];
                      summary(lm(log(-log(1-p))~log(V)))$sigma}
 O<-round(optimize(errfn,lower=Ms[m],upper=2*rs[r]*R)$minimum,0)
 op<-head(1-c(1:O)/(O+1),n=Ms[m])
#points(log(V),log(-log(1-op)),col="red",pch=2,cex=1.5,lwd=2)
#Ofit<-lm(log(-log(1-op))~log(V),weights=wt)
 Ofit<-lm(log(-log(1-op))~log(V))
#abline(Ofit,col="red",lwd=2)
 wo<-Ofit$coefficients[2]

  xms<-c(summary(pot.XMS(V,R,w))$coefficients[1:2]^(1/w),w)
  Vxms<-qximis(y,xms)
  xmw<-c(summary(pot.XMS(V,R,ww))$coefficients[1:2]^(1/ww),ww)
  Vxmw<-qximis(y,xmw)
  xmo<-c(summary(pot.XMS(V,R,wo))$coefficients[1:2]^(1/wo),wo)
  Vxmo<-qximis(y,xmo)

#plot(y,sort(V,decreasing=TRUE),cex=1.5)
#lines(y,Vxms,lwd=3)
#lines(y,Vxmw,lwd=3,col="red",lty=2)
#lines(y,Vxmo,lwd=3,col="blue",lty=3)

  z<-data.frame(Uxms=xms[1],Dxms=xms[2],
      Uxmw=xmw[1],Dxmw=xmw[2],wxmw=xmw[3],
      Uxmo=xmo[1],Dxmo=xmo[2],wxmo=xmo[3],
      X50=qximis(y50,xms),W50=qximis(y50,xmw),O50=qximis(y50,xmo),
      X100=qximis(y100,xms),W100=qximis(y100,xmw),O100=qximis(y100,xmo),
      X1000=qximis(y1000,xms),W1000=qximis(y1000,xmw),O1000=qximis(y1000,xmo),
      X10000=qximis(y10000,xms),W10000=qximis(y10000,xmw),O10000=qximis(y10000,xmo)
     )
  Z<-rbind(Z,z)
 }
 means<-c(Ms[m],rs[r],colMeans(Z))
 names(means)<-c("M","r",colnames(Z))
 variances<-c(Ms[m],rs[r],apply(Z,2,var))
 names(variances)<-c("M","r",colnames(Z))
 return(c(means,variances))
}

for (R in c(50))
{m<-c(1:nM)
 tic<-Sys.time()
 Out<-numeric()
 for (r in c(1:nr))
 {out<-t(sapply(m,boot,r=r))
  Out<-rbind(Out,out)
 }
 print(Sys.time()-tic)
 Means<-as.data.frame(Out[,1:22])
 Variances<-as.data.frame(Out[,23:44])
 rownames(Means)<-NULL
 rownames(Variances)<-NULL

 save(Means,Variances,file=paste("BootData/WeibPotBoot.w",w,".R",R,".Rdata",sep=""))
}

#round(Means,4)
#round(Variances,4)

}#

