

 getwd()
 source(file.path(WERinR,"Recipes/EVA/EVA-functions.R"))
 Print<-function(x) {cat(x,"\n");  flush.console()}
 library(akima)

qgev=function(gev,P){gev[1]+gev[2]/gev[3]*((-log(P))^-gev[3]-1)}


 print(load("GEVBoot.Rdata"))

 ws<-unique(means$w)
 Rs<-unique(means$R)
 PIs<-unique(means$PI)
 nw<-length(ws)
 nR<-length(Rs)
 nPI<-length(PIs)



SVG=FALSE

MRI=10000
method<-"G"
Name<-paste(method,MRI,sep="")
levels<-c(-1,0,1,2,5)
levels<-c(levels/10000,levels/1000,levels/100,levels/10,levels,levels*10,levels*100)
pal = col = hcl.colors(100, "YlOrRd", rev = TRUE)

#=========================================================================
#		Bias and variance for each R
#-------------------------------------------------------------------------
graphics.off()
# mean bias
for (R in Rs)
{Lim=c(-0.2,1)
 Mx<-means[means$R==R,]
 V<-Mx[,Name]
 Vtgt<-V
 for (i in c(1:length(V)))
  Vtgt[i]<-qgev(c(Mx$mu[i],Mx$sigma[i],Mx$xi[i]),1-1/MRI)
 V<-(V/Vtgt)-1
 mx<-interp(Mx$PI,Mx$w,V,nx=nPI*10,ny=nw*10,linear=TRUE)
 if (SVG){svg(paste("GEV.Bias.",Name,".R",R,".svg",sep=""))}else{dev.new()}

 contour(mx,labcex=1,lwd=2,levels=levels,
   main=bquote(bold("Bias error of"~.(Name)~"for "~italic(R)==.(R))),
    ylab=expression("Weibull index, "~italic(w)),
   xlab=expression("Characteristic product, "~italic(Pi)))

 box(lwd=2)
 mtext(bquote(bar(epsilon)(italic(V)[.(MRI)])/~italic(V)[.(MRI)]))
 if (SVG)dev.off()
}

graphics.off()
# variances
for (R in Rs)
{Lim=c(log(1e-5),log(10))
 Mx<-variances[variances$R==R,]
 V<-Mx[,Name]
 Vtgt<-V
 for (i in c(1:length(V)))
  Vtgt[i]<-qgev(c(Mx$mu[i],Mx$sigma[i],Mx$xi[i]),1-1/MRI)
 V<-sqrt(V)/Vtgt
 mx<-interp(Mx$PI,Mx$w,V,nx=nPI*10,ny=nw*10,linear=TRUE)
 if (SVG){svg(paste("GEV.StdErr.",Name,".R",R,".svg",sep=""))}else{dev.new()} 

 contour(mx,labcex=1,lwd=2,levels=levels,
 main=bquote(bold("Standard error of"~.(Name)~"for "~italic(R)==.(R))),
    ylab=expression("Weibull index, "~italic(w)),
    xlab=expression("Characteristic product, "~italic(Pi)))

 box(lwd=2)
 mtext(bquote(bar(sigma)(italic(V)[.(MRI)])/~italic(V)[.(MRI)]))
 if (SVG)dev.off()
}

#===========================================================================
#			Shape and scale
#---------------------------------------------------------------------------
# Get datum epoch data
print(load("GEVBoot.Rdata"))

graphics.off()
# svg("GEV.shape.svg")
M<-means[means$R==20,]
plot(M$xi,M$shp,xlab="Source shape parameter",ylab="Ensemble mean",
  main="GEV method shape parameter: Ensemble mean",lwd=2,cex=1.5,col="red")
M<-means[means$R==50,]
points(M$xi,M$shp,pch=0,col="blue",lwd=2,cex=1.2)
M<-means[means$R==10,]
points(M$xi,M$shp,pch=2,col="green4",lwd=2,cex=1.2)
abline(0,1,lwd=2)
mtext("Sampled from GEV source distribution")
box(lwd=2)
legend("topleft",c("R=10","R = 20","R = 50"),pch=c(2,1,0),
  col=c("green4","red","blue"),bty="n",pt.cex=c(1.2,1.5,1.2),pt.lwd=2)
#dev.off()


dev.new()
# svg("GEV.scale.svg")
M<-means[means$R==20,]
plot(M$sigma,M$Dgev,xlab="Source scale parameter",ylab="Ensemble mean",
  main="GEV method scale parameter: Ensemble mean",lwd=2,cex=1.5,col="red")
M<-means[means$R==50,]
points(M$sigma,M$Dgev,pch=0,col="blue",lwd=2,cex=1.2)
M<-means[means$R==10,]
points(M$sigma,M$Dgev,pch=2,col="green4",lwd=2,cex=1.2)
abline(0,1,lwd=2)
mtext("Sampled from GEV source distribution")
box(lwd=2)
legend("topleft",c("R=10","R = 20","R = 50"),pch=c(2,1,0),
  col=c("green4","red","blue"),bty="n",pt.cex=c(1.2,1.5,1.2),pt.lwd=2)
#dev.off()

dev.new()
# svg("GEV.location.svg")
M<-means[means$R==20,]
plot(M$mu,M$Ugev,xlab="Source location parameter",ylab="Ensemble mean",
  main="GEV method location parameter: Ensemble mean",lwd=2,cex=1.5,col="red")
M<-means[means$R==50,]
points(M$mu,M$Ugev,pch=0,col="blue",lwd=2,cex=1.2)
M<-means[means$R==10,]
points(M$mu,M$Ugev,pch=2,col="green4",lwd=2,cex=1.2)
abline(0,1,lwd=2)
mtext("Sampled from GEV source distribution")
box(lwd=2)
legend("topleft",c("R=10","R = 20","R = 50"),pch=c(2,1,0),
  col=c("green4","red","blue"),bty="n",pt.cex=c(1.2,1.5,1.2),pt.lwd=2)
#dev.off()


graphics.off()
# svg("GEV.shape.SD.svg")
M<-means[means$R==20,]
V<-sqrt(variances[variances$R==20,])
plot(M$xi,V$shp,xlab="Source shape parameter",ylab="Standard deviation",
  main="GEV method shape parameter: Standard deviation",lwd=2,cex=1.5,col="red",ylim=c(0,0.6))
M<-means[means$R==50,]
V<-sqrt(variances[variances$R==50,])
points(M$xi,V$shp,pch=0,col="blue",lwd=2,cex=1.2)
M<-means[means$R==10,]
V<-sqrt(variances[variances$R==10,])
points(M$xi,V$shp,pch=2,col="green4",lwd=2,cex=1.2)
mtext("Sampled from GEV source distribution")
box(lwd=2)
legend("topleft",c("R=10","R = 20","R = 50"),pch=c(2,1,0),
  col=c("green4","red","blue"),bty="n",pt.cex=c(1.2,1.5,1.2),pt.lwd=2)
#dev.off()

dev.new()
# svg("GEV.scale.SD.svg")
M<-means[means$R==20,]
V<-sqrt(variances[variances$R==20,])
plot(M$sigma,V$Dgev/M$sigma,xlab="Source scale parameter",ylab="Standard error",
  main="GEV method scale parameter: Standard error",lwd=2,cex=1.5,col="red",ylim=c(0,0.4))
M<-means[means$R==50,]
V<-sqrt(variances[variances$R==50,])
points(M$sigma,V$Dgev/M$sigma,pch=0,col="blue",lwd=2,cex=1.2)
M<-means[means$R==10,]
V<-sqrt(variances[variances$R==10,])
points(M$sigma,V$Dgev/M$sigma,pch=2,col="green4",lwd=2,cex=1.2)
mtext("Sampled from GEV source distribution")
box(lwd=2)
legend("topleft",c("R=10","R = 20","R = 50"),pch=c(2,1,0),
  col=c("green4","red","blue"),bty="n",pt.cex=c(1.2,1.5,1.2),pt.lwd=2)
#dev.off()

dev.new()
# svg("GEV.location.SD.svg")
M<-means[means$R==20,]
V<-sqrt(variances[variances$R==20,])
plot(M$mu,V$Ugev/M$mu,xlab="Source location parameter",ylab="Standard error",
  main="GEV method location parameter: Standard error",lwd=2,cex=1.5,col="red",ylim=c(0,0.4))
M<-means[means$R==50,]
V<-sqrt(variances[variances$R==50,])
points(M$mu,V$Ugev/M$mu,pch=0,col="blue",lwd=2,cex=1.2)
M<-means[means$R==10,]
V<-sqrt(variances[variances$R==10,])
points(M$mu,V$Ugev/M$mu,pch=2,col="green4",lwd=2,cex=1.2)
mtext("Sampled from GEV source distribution")
box(lwd=2)
legend("topleft",c("R=10","R = 20","R = 50"),pch=c(2,1,0),
  col=c("green4","red","blue"),bty="n",pt.cex=c(1.2,1.5,1.2),pt.lwd=2)
#dev.off()

