
 getwd()
 source(file.path(WERinR,"Recipes/EVA/EVA-functions.R"))
 Print<-function(x) {cat(x,"\n");  flush.console()}
 library(akima)


pal = col = hcl.colors(100, "YlOrRd", rev = TRUE)

 R=20
 print(load(paste("WeibPotBoot.R",R,".Rdata",sep="")))

 ws<-unique(means$w)
 Ms<-unique(means$M)
 rs<-unique(means$r)
 nw<-length(ws)
 nM<-length(Ms)
 nr<-length(rs)



graphics.off()
#svg(paste("Weib.Index.R",R,".svg",sep=""))
# XMP index for Weibull index - means
{M<-means
 mx<-interp(M$r,M$w,M$wxmp,ny=nr*10,nx=nr*10,linear=TRUE)
# image(mx,
# main=bquote("Ensemble mean index for"~italic(R)==.(R)),
#   ylab=expression("Weibull Index, "~italic(w)),
#   xlab=expression("Annual rate, "~italic(r)),col=pal)
# contour(mx,add=TRUE,labcex=1,lwd=2)
 contour(mx,labcex=1,lwd=3,
  main=bquote("Ensemble mean index for"~italic(R)==.(R)),
   ylab=expression("Weibull Index, "~italic(w)),
   xlab=expression("Annual rate, "~italic(r)))
 abline(h=seq(1,4,0.5))
 box(lwd=2)
 mtext(bquote("From Weibull fit to top "~italic(M)==.(Ms)~" ranks, with"~italic(N)==italic(rR)))
}
#dev.off()

graphics.off()
# XMP index for Weibull index - stdev
{M<-variances
 mx<-interp(M$r,M$w,sqrt(M$wxmp)/M$w,ny=nr*10,nx=nr*10,linear=TRUE)
 dev.new()
 image(mx,
   ylab=expression("Weibull Index, "~italic(w)),
   xlab=expression("Annual rate, "~italic(r)),col=pal,
   main=bquote("Standard error of Index for"~italic(M)==.(Ms)~~italic(R)==.(R)))
 contour(mx,add=TRUE,labcex=1,lwd=2)
 box(lwd=2)
 mtext(expression(sigma[italic(w)]/italic(w)))
}


graphics.off()
# XMO index for Weibull index - means
#svg(paste("OptWeib.Index.R",R,".svg",sep=""))
{M<-means
 mx<-interp(M$r,M$w,M$wxmo,ny=nr*10,nx=nr*10,linear=TRUE)
#image(mx,
#main=bquote("Ensemble mean Index for"~italic(R)==.(R)),
#  ylab=expression("Weibull Index, "~italic(w)),
#  xlab=expression("Annual rate, "~italic(r)),col=pal)
#contour(mx,add=TRUE,labcex=1,lwd=2)
  contour(mx,labcex=1,lwd=3,
   main=bquote("Ensemble mean Index for"~italic(R)==.(R)),
   ylab=expression("Weibull Index, "~italic(w)),
   xlab=expression("Annual rate, "~italic(r)))
 abline(h=seq(1,4,0.5))
 box(lwd=2)
 mtext(bquote("From optimised Weibull fit to top "~italic(M)==.(Ms)~" ranks"))
}
#dev.off()

graphics.off()
# XMO index for Weibull index - stdev
{M<-variances
 mx<-interp(M$r,M$w,sqrt(M$wxmo)/M$w,ny=nr*10,nx=nr*10,linear=TRUE)
 dev.new()
 image(mx,
   ylab=expression("Weibull Index, "~italic(w)),
   xlab=expression("Annual rate, "~italic(r)),col=pal,
   main=bquote("Standard error of Index for"~italic(M)==.(Ms)~~italic(R)==.(R)))
 contour(mx,add=TRUE,labcex=1,lwd=2)
 box(lwd=2)
 mtext(expression(sigma[italic(w)]/italic(w)))
}

#svg(paste("StdErr.Index.R",R,".svg",sep=""))
M<-variances
plot(M$r,sqrt(M$wxmp)/M$w,xlab=expression("Annual rate, "~italic(r)),cex=1.5,lwd=2,
   ylab=expression("Standard error of Index,"~sigma[italic(w)]/italic(w)),
  main=bquote("Ensemble standard error of Index for"~italic(R)==.(R)),
  ylim=c(0.07,0.2))
points(M$r,sqrt(M$wxmo)/M$w,cex=1.2,lwd=2,pch=2,col="red")
legend("right",c("Left-censored parent","Optimised"),bty="n",
   pch=c(1,2),pt.cex=c(1.5,1.2),col=c("black","red"),pt.lwd=2) 
mtext(bquote("From Weibull fit to top "~italic(M)==.(Ms)~" ranks"))
 box(lwd=2)
#dev.off()

mxit<-function(col)
 {matrix(col,c(nr,nw),dimnames=list(r=rs,w=ws))}


# MEANS =====================================================

# XMP index convergence
mx<-mxit(means$wxmp)
plot(rs,mx[,1],lwd=2,typ="b",xlab="Annual rate, r",
  ylim=range(mx),log="x",
  ylab="GRW index",main=paste("Weibull index convergence for R =",R) )
for (w in c(2:length(ws)))
 points(rs,mx[,w],typ="b",lwd=2)
abline(h=ws)

# XMP index convergence error
mx<-mxit(means$wxmp)
mmx<-t(t(mx)/ws-1)
x<-rowMeans(mmx)
plot(rs,x,lwd=2,typ="b",xlab="Annual rate, r",
  ylim=c(-0.02,0),log="x",
  ylab="Index fractional error, e(w)/w",main=paste("Weibull index error convergence for R =",R))
abline(h=0)
mtext("From Weibull fit to left-censored parent")

# STDEV =====================================================

# XMW index standard deviation intensity
mx<-mxit(variances$wxmp)
mmx<-t(t(mx)/ws)
mmx<-sqrt(mmx)
image(log10(rs),ws,log(mmx),
 main=paste("Standard deviation intensity of Index for R =",R),
 xlab="Annual rate, r",ylab="Index, w",col=pal,xlim=c(1,log10(max(rs))),
 xaxt="n")
axis(1,at=log10(c(10,20,50,100,200,500)),labels=c(10,20,50,100,200,500))
abline(v=log10(c(seq(10,90,10),seq(100,500,100))),col="grey")
abline(h=seq(0.5,4,0.5),col="gray")
contour(log10(rs),ws,mmx,add=TRUE,labcex=1,lwd=2)
mtext("From Weibull fit to left-censored parent")
box(lwd=2)


#=================================================================================================



 R=20
 print(load(paste("WeibPotBoot.R",R,".Rdata",sep="")))

 ws<-unique(means$w)
 Ms<-unique(means$M)
 rs<-unique(means$r)
 nw<-length(ws)
 nM<-length(Ms)
 nr<-length(rs)


MRI=10000
method<-"O"
Name<-paste(method,MRI,sep="")
levels<-c(-1,0,1,2,5)
levels<-c(levels/10000,levels/1000,levels/100,levels/10,levels,levels*10,levels*100)
levels<-sort(unique(levels))
pal = col = hcl.colors(100, "YlOrRd", rev = TRUE)


graphics.off()
# means
{Lim=c(log(5e-5),log(1))
 V<-means[,Name]/means[,paste("X",MRI,sep="")]-1
 mx<-interp(means$r,means$w,V,nx=nr*10,ny=nw*10,linear=TRUE)
 dev.new()
 image(log10(mx$x),mx$y,log(mx$z),
    main=bquote("Bias error of"~.(Name)~"for "~italic(M)==.(Ms)~","~italic(R)==.(R)),
    ylab=expression("Index, "~italic(w)),
    xlab=expression("Annual rate, "~italic(r)),col=pal,zlim=Lim,
  xaxt="n")
axis(1,at=log10(c(10,20,50,100,200,500)),labels=c(10,20,50,100,200,500))
abline(v=log10(c(seq(10,90,10),seq(100,500,100))),col="grey")
abline(h=seq(0.5,4,0.5),col="gray")
 contour(log10(mx$x),mx$y,mx$z,add=TRUE,labcex=1,lwd=2,level=levels)
 box(lwd=2)
# mtext(bquote("Mean bias error / "~italic(V)[.(MRI)])) 
 mtext(bquote(bar(epsilon)(italic(V)[.(MRI)])/~italic(V)[.(MRI)]))
}

graphics.off()
# variances
{Lim=c(log(5e-5),log(1))
 V<-sqrt(variances[,Name])/means[,paste("X",MRI,sep="")]
 mx<-interp(variances$r,variances$w,V,nx=nr*10,ny=nw*10,linear=TRUE)
 dev.new()
 image(log10(mx$x),mx$y,log(mx$z),
    main=bquote("Standard error of"~.(Name)~"for "~italic(M)==.(Ms)~","~italic(R)==.(R)),
    ylab=expression("Index, "~italic(w)),
    xlab=expression("Annual rate, "~italic(r)),col=pal,zlim=Lim,xaxt="n")
  axis(1,at=log10(c(10,20,50,100,200,500)),labels=c(10,20,50,100,200,500))
abline(v=log10(c(seq(10,90,10),seq(100,500,100))),col="grey")
abline(h=seq(0.5,4,0.5),col="gray")
 contour(log10(mx$x),mx$y,mx$z,add=TRUE,labcex=1,lwd=2,level=levels)
 box(lwd=2)
 mtext(bquote(bar(sigma)(italic(V)[.(MRI)])/~italic(V)[.(MRI)])) 
}


#========================================================================
# XMP index convergence error R = 20, 50

R=20
print(load(paste("WeibPotBoot.R",R,".Rdata",sep="")))
mx<-mxit(means$wxmp)
mmx<-t(t(mx)/ws-1)
x<-rowMeans(mmx)
plot(rs*R,x,lwd=2,typ="b",cex=1.5,
  xlab=expression("Population of observations,"~italic(N)==italic(rR)),
  ylim=c(-0.02,0),log="x",xlim=c(100,25000),
  ylab=expression("Index fractional error,"~~italic(epsilon)[italic(w)]/italic(w)),
  main=paste("Weibull index error convergence"))
abline(h=0,lwd=3,lty=2)
mtext("From Weibull fit to left-censored parent")
R=50
print(load(paste("WeibPotBoot.R",R,".Rdata",sep="")))
mx<-mxit(means$wxmp)
mmx<-t(t(mx)/ws-1)
x<-rowMeans(mmx)
points(rs*R,x,lwd=3,typ="b",pch=0,col="red")
legend("bottomright",c(expression(italic(R)==20),expression(italic(R)==50)),
   pch=c(1,0),col=c("black","red"),lwd=c(2,3),bty="n")


# XMO index convergence error R = 20, 50

R=20
print(load(paste("WeibPotBoot.R",R,".Rdata",sep="")))
mx<-mxit(means$wxmo)
mmx<-t(t(mx)/ws-1)
x<-rowMeans(mmx)
plot(rs*R,x,lwd=2,typ="b",cex=1.5,
  xlab=expression("Population of observations,"~italic(N)==italic(rR)),
  log="x",xlim=c(100,25000),
  ylab=expression("Index bias error,"~~italic(epsilon)[italic(w)]/italic(w)),
  main=paste("Weibull index bias error convergence"))
abline(h=0,lwd=3,lty=2)
mtext("From optimised Weibull fit")
R=50
print(load(paste("WeibPotBoot.R",R,".Rdata",sep="")))
mx<-mxit(means$wxmo)
mmx<-t(t(mx)/ws-1)
x<-rowMeans(mmx)
points(rs*R,x,lwd=3,typ="b",pch=0,col="red")
legend("bottomright",c(expression(italic(R)==20),expression(italic(R)==50)),
   pch=c(1,0),col=c("black","red"),lwd=c(2,3),bty="n")


# XMO index standard deviation R = 20, 50

R=20
print(load(paste("WeibPotBoot.R",R,".Rdata",sep="")))
mx<-mxit(sqrt(variances$wxmo)/variances$w)
x<-rowMeans(mx)
plot(rs*R,x,lwd=2,typ="b",cex=1.5,
  xlab=expression("Population of observations,"~italic(N)==italic(rR)),
  log="x",xlim=c(100,25000),
  ylab=expression("Index standard error,"~~italic(sigma)[italic(w)]/italic(w)),
  main=paste("Weibull index standard error convergence"))
abline(h=0,lwd=3,lty=2)
mtext("From optimised Weibull fit")
R=50
print(load(paste("WeibPotBoot.R",R,".Rdata",sep="")))
mx<-mxit(sqrt(variances$wxmo)/variances$w)
x<-rowMeans(mx)
points(rs*R,x,lwd=3,typ="b",pch=0,col="red")
legend("topright",c(expression(italic(R)==20),expression(italic(R)==50)),
   pch=c(1,0),col=c("black","red"),lwd=c(2,3),bty="n")


